#include "bedelingen.h"

using namespace std;

void Bedelingen::own()
{
     string hand;
     for (int idx = 4; idx > 0; --idx)
     {
         int aantal = 4 - d_available[idx];
         char symbol;
         switch (idx)
         {
            case 4:
                 symbol = 'A';
                 break;
            case 3:
                 symbol = 'K';
                 break;
            case 2:
                 symbol = 'Q';
                 break;
            case 1:
                 symbol = 'J';
                 break;
         }
                 
         hand.append(aantal, symbol);         
     }
     d_bedelingen.push_back(hand);
}     

void Bedelingen::bereken(int min, int max)
{
     for (int idx = min; idx <= max; ++idx)
     {      
            berekenHand(idx);
     }
}

void Bedelingen::berekenHand(int hcps)
{
     bool total = true;
     string high = highestHand(hcps, highestAvailable(), "", total);
     while (1)
     {
           if (high != "" && total)
              d_bedelingen.push_back(high);
           
           high = breek(high);
           if (high == "")
              break;
           
           high = vulaan(high, hcps);
           total = true;
     }
}

int Bedelingen::highestAvailable()
{
    for (int idx = 4; idx > 0; --idx)
    {
        if (d_available[idx] != 0)
           return idx;
    }
    return 0;
}

string Bedelingen::highestHand(int points, int highestcard, string current, bool &partial)
{
       string hand = current;
       
       while (d_available[highestcard] == 0)
       {
             if (--highestcard == 0)
             {
                if (partial)
                {
                    partial = false;
                    return hand;
                }
                return "";
             }
       }
       
       int max  = points / highestcard;
       if (max > d_available[highestcard])
          max = d_available[highestcard];
       
       int rest = points - max * highestcard;
       
       hand.append(max, symbol(highestcard));
       
       if (rest == 0)
       {
          return hand;
       }
 
       if (highestcard > 1)
          hand = highestHand(rest, highestcard - 1, hand, partial);      
       
       return (highestcard == 1 && !partial) ? "" : hand;
}

char Bedelingen::symbol(int card)
{
     switch(card)
     {
            case 4:
                 return 'A';
            case 3:
                 return 'K';
            case 2:
                 return 'Q';
            case 1:
                 return 'J';
     }
     return '?';
}

string Bedelingen::breek(string hand)
{
       unsigned leastsig = hand.find_last_not_of('J');
       if (leastsig == string::npos)
          return "";
          
       char card = hand.at(leastsig);
       card = decrement(card);
       
       hand.erase(leastsig);
       hand.append(1,card);

       return hand;
}

char Bedelingen::decrement(char c)
{
     switch(c)
     {
           case 'A':
                return 'K';
           case 'K':
                return 'Q';
           case 'Q':
                return 'J';
     }
     return c;
}
           


string Bedelingen::vulaan(string hand, int points)
{
       if (hand == "")
          return hand;
     
       int highestcard(4);
       int curpoints = points;
       int avail[5];
       avail[4] = d_available[4]; avail[3] = d_available[3]; avail[2] = d_available[2]; avail[1] = d_available[1];
       
       for (unsigned idx = 0; idx < hand.size(); ++idx)
       {
           char c = hand.at(idx);
           switch (c)
           {
                  case 'A':
                       highestcard = 4;
                       curpoints -= 4;
                       d_available[4]--;
                       break;
                  case 'K':
                       highestcard = 3;
                       curpoints -= 3;
                       d_available[3]--;
                       break;
                  case 'Q':
                       highestcard = 2;
                       curpoints -= 2;
                       d_available[2]--;
                       break;
                  case 'J':
                       highestcard = 1;
                       curpoints--;
                       d_available[1]--;
                       break;
           }
       }
       bool succes = (d_available[4] >= 0 && d_available[3] >= 0 && d_available[2] >= 0 && d_available[1] >= 0);
       
       if (curpoints < 1)
          return hand;
       
       string fullhand = succes ? highestHand(curpoints, highestcard, hand, succes) : "";    

       d_available[4] = avail[4]; d_available[3] = avail[3]; d_available[2] = avail[2]; d_available[1] = avail[1];
       
       if (!succes)
       {
            hand = breek(fullhand == "" ? hand : fullhand);
            hand = vulaan(hand, points);
            return hand;
       }
       
       return fullhand;
}
