#include "player.ih"

// partner opened, reply.... 
pair<int, int> player::friendlyBid( pair<int, int> openingBid, pair<int, int> lastBid )
{
    d_lastBid = lastBid;      
        
          
// when partner opened one in a suit:
    if( openingBid.first == 1 && openingBid.second != 4 ) // 4 being 'Sans'
    {
        // check for support in requested and higher suits:
        int supportInSuit, higher4Card;
        for( int idx = 0; idx < 4; ++idx)
        {
            if(suitfrequencies[idx].second == openingBid.second)
                supportInSuit = suitfrequencies[idx].second;
            if(suitfrequencies[idx].second > openingBid.second && suitfrequencies[idx].first >= 4)
                higher4Card = suitfrequencies[idx].second;
        }
        
    // 4-card support in suit
        if( supportInSuit >= 4 )
        {
            if(d_points > 5 && d_points < 10)
            {
                return printBid( cout, 2, openingBid.second );
            }    
            if(d_points == 10 || d_points == 11)
            {    
                return printBid( cout, 3, openingBid.second );
            }
            if(d_points > 11)
            {    
                return printBid( cout, 4, openingBid.second );
            }
        }

    // no 4-card suit support, or 4 card suit support in a higher suit
        if( !(supportInSuit >= 4) )
        {
            if(d_points > 5 && d_points < 10)
            {
                return printBid( cout, 1, 4);
            }
            if(d_points >= 10 && d_points <= 11)
            {
                return printBid( cout, 2, 4);                
            }
        }
        
        if(d_points > 11)
        {
            return printBid(cout, lastBid.first +1, suitfrequencies[3].second);
        }
  
    } // ending opening by one in a suit
    
// when partner opened 1 Sans
    if( openingBid.first == 1 && openingBid.second == 4) // 4 being 'Sans'
    {
        // when 'NT-distribution':
        if(d_NTDistribution)
        {
            if(d_points == 9)
            {
                return printBid( cout, 2, 4 );
            }
            if(d_points >= 10 && d_points <= 15)
            {
                return printBid( cout, 3, 4 );
            }
        }
        
        // when no-'NT-distribution' but with 5-card in a suit:
        else 
        {
            cout << "1"; 
            // 5-card is only possible for the two longest suits
            for(int idx = 3; idx > 1; --idx)
            {
                if(suitfrequencies[idx].first >= 5)
                {
                    cout << "2";
                    if(d_points < 8 && suitfrequencies[idx].second != card::Clubs)
                    {
                        cout << "3";
                        return printBid( cout, 2, suitfrequencies[idx].second );
                    }
                    if(d_points >= 8 && d_points <= 10)
                    {
                        cout << "!";
                        return printBid( cout, 3, suitfrequencies[idx].second );
                    }
                }
                if(suitfrequencies[idx].first == 4 && d_points >= 8 &&
                    (   suitfrequencies[idx].second == card::Spades 
                     || suitfrequencies[idx].second == card::Hearts   )     )
                {
                        cout << "?";
                        return printBid(cout, 2, 0);
                }
                if(d_points > 10)
                {
                        return printBid(cout, 2, 0);    
                }
                
            }
        }
    }

    // when partner opened 2 Sans
    if( openingBid.first == 2 && openingBid.second == 4) // 4 being 'Sans'
    {    
        // check for four hears or four spades 
        bool fourHorS = false;    
        for(int idx = 0; idx < 4; ++idx)
        {   
            if(suitfrequencies[idx].first == 4 && (suitfrequencies[idx].second == 3 || suitfrequencies[idx].second == 4) )
                fourHorS = true;
        }
                      
        if(d_points >= 5 && d_points <= 11 && !fourHorS) // in case of 5-11 pts, no 4-card hearts or spades
        {
             return printBid(cout, 3, 4);
        }
                        
        if(d_points >= 4 && d_points <= 20) // in case of 4 - 20 pts
        {
             return printBid(cout, 3, 0);
        }
    }
    
    // when partner opened 2 clubs
    if( openingBid.first == 2 && openingBid.second == 0)
    {        
        if(d_points <= 6)                  // in case of <6 pts
        {
            return printBid(cout, 2, 1);
        }
        else
        {
            return printBid(cout, 3, suitfrequencies[3].second);
        }
    }    

    return printBid( cout, 0, 0);
}
