#include "player.ih"

void player::printPlayer()
{
    switch(d_id)
    {
        case(player::North):
            cout << "North bids:\t";
            break;
        case(player::East):
            cout << "East  bids:\t";
            break;
        case(player::South):
            cout << "South bids:\t";
            break;
        case(player::West):
            cout << "West  bids:\t";
            break;
        default:
            cout <<"Player name: "<< d_id <<" not recognised!";
    }
}

void player::printSuit(ostream &ostr, int suit)
{
    switch(suit)
    {
        case card::Clubs:
            ostr << char(5);     
            break;
        case card::Diamonds:
            ostr << char(4);     
            break;
        case card::Hearts:
            ostr << char(3);     
            break;
        case card::Spades:
            ostr << char(6);     
            break;
        case 4:
            ostr << "NT";
            break;
        default:
            ostr << "suit "<< suit <<"not recognised";
    }
}

pair<int, int> player::printBid(ostream &ostr, int num, int suit)
{   
    printPlayer();
    
    // check if bid is high enough
    if(num != 0)
    {
        if(d_lastBid.first != 0 && num < d_lastBid.first)
        {
            cout << "desired bid: " << num;
            num = 0;
            printSuit(cout, suit);
            cout << "   ";
        }
        if(d_lastBid.first != 0 && num == d_lastBid.first && suit <= d_lastBid.second)
        {
            cout << "desired bid: " << num;
            num = 0;
            printSuit(cout, suit);
            cout << "   ";
        }
    }

    if( num == 0 )
    {
        ostr << "pass\n";
        return pair<int, int> (0, 0);
    }
    ostr << num;
    switch(suit)
    {
        case card::Clubs:
            ostr << char(5);     
            break;
        case card::Diamonds:
            ostr << char(4);     
            break;
        case card::Hearts:
            ostr << char(3);     
            break;
        case card::Spades:
            ostr << char(6);     
            break;
        case 4:
             ostr << "NT";
             break;
    }   
    ostr << "\n"; 
    
    return pair<int, int> (num, suit);
}

